variables:
  DOCKER_DRIVER: overlay2
  REGISTRY_URL: registry.gitlab.com

stages:
  - build

build:
  image: docker:stable
  services:
    - docker:dind
  stage: build
  variables:
    CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH
    CONTAINER_IMAGE_TAG: $CI_COMMIT_REF_NAME-latest
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $REGISTRY_URL
    - apk add --update nodejs nodejs-npm
  script:
    - npm i
    - CI=false npm run build
    - docker pull $CONTAINER_IMAGE:$CONTAINER_IMAGE_TAG || true
    - docker build --cache-from $CONTAINER_IMAGE:$CONTAINER_IMAGE_TAG --tag $CONTAINER_IMAGE:$CONTAINER_IMAGE_TAG .
    - docker push $CONTAINER_IMAGE:$CONTAINER_IMAGE_TAG
  environment:
    name: staging
  only:
    - stage
    - master
